/*This program is the dos32 based version (xx.xxx.xxx.dos32.x)
/*The versioning format for these programs is as follows:
/*   aa.bbb.ccc.ddddd.x
/*  aa=major release version (00 in development)
/*  bbb=minor release version (000 in alpha development)
/*  ccc=internal revision
/*  ddddd=platform: dos32, dos16, win32, win16, 68k, ppc, linux
/*  x=status: a=alpha(development), b=beta(out testing), 
/*            c=gamma(pre-release), r=release

/*This program is:  e2emu32.exe
/*                  e2emu32.c
/* requires			linktic.h
/*					glinktic.h
/*					e2rout.h
/*					e2emu.h
/*					e2genr.h
/*                  stdio.h
/*                  conio.h
/*			        stdlib.h
/*					dos.h
/*					dir.h
/*					string.h
*/

/*

----EII Emulation Program, for multiple platforms----
Major Release 00, Minor Release 002, Internal Revision 095, for the
	32-bit DOS platform, Beta Status
*/
#define vers	"v00.002.095.dos32.b"
/*

Copyright (c) 1998-1999, Ingenious Engineering 
Most Code is Copyright (c) 1998-1999, Jonathan Kaus and Ingenious 
	Engineering
The copyright for the other code is held by the various programmers who
    did the work on it.
The E2 is a copyright of Bryan Rittmeyer.

CODERS:
   Jonathan Kaus	Made it work.  I put down the basis for the rest of the whole program.
					the only things left to do is to fill in some routines, make the 
					Graphlink work, and port it to other platforms.  Interface work could 
					be done by anyone ambitous.  


<NOTE TO ALL WHO WORK ON THIS SOURCE:>
	PLEASE ADD YOUR NAME AND ACCOMPLISHMENT TO THE ABOVE LIST.  ALSO, KEEP THE CODING HISTORY SEMI-UP-TO-DATE AT LEAST.  PLEASE DON'T MODIFY MY COPYRIGHT INFORMATION.  ALL I ASK IS THAT IF YOU MODIFY THIS SOURCE, YOU LET ME POST IT AT THE INFOSITE FOR OTHERS TO USE, VIEW, SEE, LEARN FROM, MODIFY, ETC.  GOOD LUCK.
						-JONATHAN KAUS, ORIGINAL AUTHOR
<END OF NOTE>



CODING HISTORY:
   11/06/1998		preliminary coding began
   12/09/1998		a little bit more work is done
   12/28/1998		touched up the preliminary code outline and the header code
   01/01/1999	<-  in this month, i worked off and on all month long.
	01/31/1999	->
   02/01/1999	<-	Heavy, Heavy work.  Made great strides.
	02/05/1999	->
   02/06/1999		More work done today.  Perfecting the timeout stuff (??) as
					well as touching up the general code and removing non-
					important stuff.
   02/07/1999		Moved to Beta status after i fixed a bug that would not write
					any data to the Virtual EII memory.  Other general touchups. 
					First Released to public. (0.1.48?)
   02/08/1999		already onto 0.1.52
   02/09/1999		0.1.52 didnt work right so i had to fix it. added a few more things
					also, began process of switching over to the classic interface design 
					(0.2.54)
   02/10/1999	<-	heavy work on new CID: 0.2.54
	02/11/1999	->
   02/12/1999		Lots of work.  near-release touches
   02/13/1999		Gone all day long :)
   02/14/1999		Did final touch ups.  Began testing 0.2.80 for release
   02/15/1999		Resumed testing of 0.2 release (now at 0.2.82 stage)
   02/16/1999		More testing on the new release, now 0.2.86. All commands word as
					planned, but I still need to test actual emulation operation. I
					will be doing that tonight.  Everything seems up to par.  One thing 
					tho, The graphlink mode still doesnt work, and the A or port command 
					does not accept hex values yet.  Hmmm.  I think another release tonight 
					or tomorrow.  Fixed problem above.  Now on 0.2.88.  Will release this 
					one me thinks.
   02/17/1999  <-   On these two days, I did absolutely nothing :)
    02/18/1999  ->
   02/19/1999		Finally back on the job, I put in some routines that _should_ work for
					for the Graphlink, but I have no clue as to whether or not they
					actually work.  up to 0.2.95
   02/20/1999  <-   Apparently, I did nothing at all in this multi-month span.  Sorry for 
	05/17/1999  ->  that, and for not releasing the source earlier.  I think the main DHOS 
					kernal and such will be my main concern now.
   05/18/1999		Last day that I work on this source much.....  I made the public
					release to the infosite today.  Good luck to any of you who look at 
					it... (or better yet, add to it!)


					




*/
char version[]=vers;


#include <conio.h>
#include <stdio.h>
#include <string.h>

#include "e2emu.h"
#include "linktic.h"
#include "glinktic.h"
#include "e2rout.h"
#include "e2genr.h"







int main(int argc, char **argv)
     {
     ShowVersion();
     InterpretArgs(argc,argv);
     EmulationNow();
     ShowErrMsg("main","exit",0,"","No Problem");
     exit(0);
     }




void EmulationNow()
	{
	char CommandLine[256];	
	struct ManyMan parsed;	

	printf("Emulating the EII Device.....Now!\n");

	while (1)
		{

		printf("|\n");
		fflush(stdout);
		EmulateE2();
		printf("]");
		fflush(stdout);
		fgets(CommandLine,250,stdin);
		printf("\n");
		ParseCommandLine(CommandLine,&parsed);
		if (!ProcessCommandLine(&parsed))  /*this must return false if exit command, otherwise true*/
			return;
		}

	}

void EmulateE2() {
         /*when you press ESC in here, abort immeditatley (return)*/
         
         /*in here we have to use actual protocol control stuff -- recieve
         /*control bytes and process the information.
         */
         initport();
         while (1) {
               switch (WaitForCommandByteE2()) {
                      case ESC_PRSS_CMD: /*esc was pressed!*/
                           return;
                      case DAT_WRIT_CMD:
                           WriteDataCmdE2();
                           break;
                      case DAT_READ_CMD:
                           ReadDataCmdE2();
                           break;
                      case CNT_STTM_CMD:
                           MemChipStatReqE2();
                           break;
                      case CNT_REV2_CMD:
                           DeviceRevReqE2();
                           break;
                      case CNT_CPYR_CMD:
                           CpyRtReqE2();
                           break;
                      case MOD_SEND_CMD:
                           ModPortInvalid();
                           break;
                      case MOD_RECV_CMD:
                           ModPortInvalid();
                           break;
                      case MOD_DIRC_CMD:
                           ModPortInvalid();
                           break;
                      default:
                      }
               }
        }



